%define apache_dir /usr/local/apache2
%define apache_ver 2.0.48
%define apr_ver 0.9.5
%define contentdir /var/www
Summary: The most widely used web server on the Internet.
Name: apache
Version: %{apache_ver}
Release: 0.1
Group: System Environment/Daemons
Source: ftp://ftp.apache.org/apache/dist/apache-%{apache_ver}.tar.gz
Source1: apr-%{apr_ver}.tar.gz
Source2: apr-util-%{apr_ver}.tar.gz
Source7: httpd.init
Source8: apache.logrotate
Source14: apache.sysconf
Patch0: apache.ssl.Makefile.patch
License: Apache Group License
BuildRoot: %{_tmppath}/apache-root
BuildPrereq: db4-devel, findutils, perl
Requires: /etc/mime.types, gawk, file, /usr/bin/find
Prereq: /sbin/chkconfig, /bin/mktemp, /bin/rm, /bin/mv, /bin/sed, mailcap, grep
Prereq: textutils, /usr/sbin/useradd
Provides: webserver
Conflicts: thttpd

%description
Apache is a powerful, full-featured, efficient and freely-available
web server. Apache is also the most popular web server on the
Internet.

%package devel
Version: %{apache_ver}
Group: Development/Libraries
Summary: Development tools for the Apache web server.
Obsoletes: secureweb-devel

%description devel
The apache-devel package contains the APXS binary and other files that
you'll need to build Dynamic Shared Objects (DSOs) for Apache.

If you are installing the Apache web server, and you want to be able
to compile or develop additional modules for Apache, you'll need to
install this package.

%package manual
Version: %{apache_ver}
Group: Documentation
Summary: Documentation for the Apache web server.

%description manual
The apache-manual package contains the complete manual and reference
guide for the Apache web server.  If you need Apache documentation
installed on the local machine, install this package.  The information
can also be found on the web at http://www.apache.org/docs/.

%package libapr
Version: %{apache_ver}
Group: System Environment/Libraries
Obsoletes: apache-libapr-utils
Summary: Apache Portable Runtime libraries.

%description libapr
Apache Portable Runtime libraries.

%package libapr-devel
Version: %{apache_ver}
Group: Development/Libraries
Obsoletes: apache-libapr-utils-devel
Summary: Apache Portable Runtime development libraries.

%description libapr-devel
Apache Portable Runtime development libraries.

%changelog
* Sat Jun 14 2003 David Summers <david@summersoft.fay.ar.us> 2.0.46-0.1
- Updated to apache 2.0.46.
- Fixed bug where apache2 user/group wouldn't get created.

* Tue Apr 29 2003 David Summers <david@summersoft.fay.ar.us> 2.0.45-0.2
- Fixed logrotate bug.

* Thu Apr 03 2003 David Summers <david@summersoft.fay.ar.us> 2.0.45-0.1
- Updated to 2.0.45.
- Added SSL module Makefile patch for yacc -> bison.

* Sat Mar 01 2003 David Summers <david@summersoft.fay.ar.us> 2.0.44-0.2
- Changed httpd binary to be readable by everyone so that subversion can
  copy it temporarily to do RA_DAV tests as a non-root user.

* Wed Jan 08 2003 David Summers <david@summersoft.fay.ar.us> 2.0.43-0.4
- Updated to APR/APR-UTILS 2003.01.08.

* Sun Dec 29 2002 David Summers <david@summersoft.fay.ar.us> 2.0.43-0.3
- Combined apache-libapr and apache-libapr-utils into apache-libapr.
- Switched to db4 package from db package to be more like RedHat 8.0.
- Fixed srclib/apr/build/get-version.sh to be executable.
- Obsolete apache-libapr-utils and apache-libapr-utils-devel as they are now
- combined into the apache-libapr and apache-libapr-devel packages.

* Thu Oct 17 2002 David Summers <david@summersoft.fay.ar.us> 2.0.43-0.1
- Updated to 2.0.43.

* Wed Aug 15 2002 David Summers <david@summersoft.fay.ar.us> 2.0.41-0.1
- Updated to 2002-08-15.

* Thu Aug 08 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.9
- Added "Makefile" to the subversion repository.
- Updated to 2002-08-08.

* Sat Aug 03 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.8
- Subversion ALPHA version.  Actually this was generated some weeks ago.

* Fri Jun 28 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.6
- Updated to 2002-07-20 in preparation for Subversion ALPHA.
- Use user/group apache2/apache2 instead of default nobody/-1.

* Fri Jun 28 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.4
- Added link from httpd2 to httpd because some apache client programs and
  apxs need it.

* Sun Jun 23 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.4
- Updated to APACHE/APR/APR-UTIL 2002-06-25.
- Added error directory contents.
- Couldn't get some stuff working in previous version because of missing error/
  files.

* Sun Jun 23 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.3
- Updated to APACHE/APR/APR-UTIL 2002-06-23.

* Wed Jun 19 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.2
- Setup startup/shutdown scripts to distinguish between the "normal" 
  Redhat apache 1.3.X and the new apache-2.X servers so we can start and
  stop them separately without intererring with each other.

* Tue Jun 18 2002 David Summers <david@summersoft.fay.ar.us> 2.0.40-0.1
- Updated to 2002-06-17 APR/APR-UTIL/APACHE.
- APACHE now REQUIRES apr/apr-util in srclib so we CAN'T do anything other than
  build the APR/APR-UTIL stuff at the same time.
- APACHE now compiled in default location (/usr/local/apache2) so it should not
  interfere with the "normal" (older) RedHat apache and can run concurrently
  with it.

* Fri Apr 12 2002 David Summers <david@summersoft.fay.ar.us> 2.0.36-0.2
- Updated to 2002-04-12 APR/APR-UTIL.

* Wed Mar 06 2002 David Summers <david@summersoft.fay.ar.us> 2.0.33-0.2.
- Updated to even newer APR/APR-UTIL to catch changes necessary in Subversion.

* Wed Mar 06 2002 David Summers <david@summersoft.fay.ar.us> 2.0.33-0.1
- Went back to bundled APR/APR-UTIL.  Included apr.patch from 2.0.32-0.4.

* Sun Feb 03 2002 David Summers <david@summersoft.fay.ar.us> 2.0.31-0.5
- Updated to APR and APR-UTILS 2002.02.03.

* Sun Feb 03 2002 David Summers <david@summersoft.fay.ar.us> 2.0.31-0.4
- Broke off APR and APR-UTIL into separate packages.

* Sat Feb 02 2002 David Summers <david@summersoft.fay.ar.us> 2.0.31-0.3
- Moved APR and APR-UTIL include files out of /usr/include/apache and into
  /usr/include.

* Fri Feb 01 2002 David Summers <david@summersoft.fay.ar.us> 2.0.31-0.2
- Fixed dependency on libapr.so by including it in the package files.
- Exported APR-UTIL environment for use by other packages by including
  the apr-config and apu-config binaries.
- Enabled SSL module.

* Sat Jan 19 2002 David Summers <david@summersoft.fay.ar.us> 2.0.31-0.1
- Updated APR (2002-01-19).

* Wed Jan 02 2002 David Summers <david@summersoft.fay.ar.us> 2.0.28-0.2
- Updated to db-4.0.14.

* Tue Dec 18 2001 David Summers <david@summersoft.fay.ar.us> 2.0.28-1
- Updated to apache-2.0.28.
- Updated to apr-0.2001.12.18

* Tue Nov 06 2001 David Summers <david@summersoft.fay.ar.us> 2.0.27-2
- Fixed mime.types.

* Sat Oct 27 2001 David Summers <david@summersoft.fay.ar.us> 2.0.27-1
- Initial version copied from apache-1.3.19-5 spec file and modified.

%prep
TARGET_PLATFORM=%{_target_platform}
%define _target_platform --target=${TARGET_PLATFORM}

%setup -q -n httpd-2.0 -a 1 -a 2

# Fix up SSL module Makefile; change from yacc -> bison.
%patch0 -p0

mv apr srclib
mv apr-util srclib

if [ -f /usr/bin/automake-1.5 ]; then
   AUTOMAKE="/usr/bin/automake-1.5"
   export AUTOMAKE
fi
if [ /usr/bin/autoheader-2.53 ]; then
   AUTOHEADER="/usr/bin/autoheader-2.53"
   export AUTOHEADER
fi
if [ -f /usr/bin/autoconf-2.53 ]; then
   AUTOCONF="/usr/bin/autoconf-2.53"
   export AUTOCONF
fi

chmod a+x ./buildconf srclib/apr/buildconf srclib/apr-util/buildconf build/config-stubs build/instdso.sh build/install.sh
chmod a+x srclib/apr/build/PrintPath ./srclib/apr/build/buildcheck.sh
chmod a+x srclib/apr-util/xml/expat/buildconf.sh srclib/apr-util/xml/expat/conftools/PrintPath
chmod a+x build/mkdir.sh srclib/apr/build/mkdir.sh srclib/apr-util/build/mkdir.sh
chmod a+x srclib/apr/build/get-version.sh

./buildconf
# Per subversion documentation:
./configure \
	prefix=%{apache_dir} \
	--enable-mods-shared=all \
	--enable-ssl \
	--enable-dav

#make depend

%build
YACC="bison -y"
export YACC

make

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

echo "*** FINISHED WITH APACHE MAKE INSTALL ***"

# Move httpd binary to destination and link from httpd to httpd2.
mv $RPM_BUILD_ROOT/%{apache_dir}/bin/httpd $RPM_BUILD_ROOT/%{apache_dir}/bin/httpd2
(cd $RPM_BUILD_ROOT/%{apache_dir}/bin
ln -s httpd2 httpd
)

# remove apachectl; we have our own SYSV init stuff
rm -f $RPM_BUILD_ROOT/%{apache_dir}/bin/apachectl
rm -f $RPM_BUILD_ROOT/%{apache_dir}/man/man8/apachectl.8

# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
# Note the httpd2 (so it can co-exist with the RedHat httpd).
install -m755 $RPM_SOURCE_DIR/httpd.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/httpd2

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
# Note the apache2 (so it can co-exist with the Redhat httpd).
install -m644 $RPM_SOURCE_DIR/apache.logrotate \
	$RPM_BUILD_ROOT/etc/logrotate.d/apache2

# Fix up htdocs directory.
cp $RPM_BUILD_ROOT/%{apache_dir}/htdocs/index.html.en $RPM_BUILD_ROOT/%{apache_dir}/htdocs/index.html
cp $RPM_BUILD_ROOT/%{apache_dir}/icons/apache_pb.gif $RPM_BUILD_ROOT/%{apache_dir}/htdocs

# Fix up apache source code for devel package
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl5" | \
	xargs perl -pi -e "s|/usr/local/bin/perl5|%{__perl}|g;"
find $RPM_BUILD_ROOT -type f | \
	xargs grep -l "/usr/local/bin/perl" | \
	xargs perl -pi -e "s|/usr/local/bin/perl|%{__perl}|g;"

# clean up apxs
sed "s^$RPM_BUILD_ROOT^^g" $RPM_BUILD_ROOT/%{apache_dir}/bin/apxs > apxs.tmp && \
cat apxs.tmp > $RPM_BUILD_ROOT/%{apache_dir}/bin/apxs

# Fix envvars executable mode.
chmod a+x $RPM_BUILD_ROOT/%{apache_dir}/bin/envvars

# Clean out any CVS directories in the distribution.
find $RPM_BUILD_ROOT/%{apache_dir} -name CVS -exec rm -rf {} \; || true

# Patch httpd.conf for apache2 user and group.
(cd $RPM_BUILD_ROOT/%{apache_dir}/conf;
sed -e 's/^User nobody/User apache2/' \
    -e 's/^Group #-1/Group apache2/' < httpd.conf > httpd.conf.new && mv httpd.conf.new httpd.conf
)

%clean
#rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add httpd2
# safely add .htm to mime types if it is not already there
[ -f /usr/local/apache/conf/mime.types ] || exit 0
TEMPTYPES=`/bin/mktemp /tmp/mimetypes.XXXXXX`
[ -z "$TEMPTYPES" ] && {
  echo "could not make temporary file, htm not added to /usr/local/apache2/conf/mime.types" >&2
  exit 1
}
( grep -v "^text/html"  /usr/local/apache2/conf/mime.types
  types=$(grep "^text/html" /usr/local/apache2/conf/mime.types | cut -f2-)
  echo -en "text/html\t\t\t"
  for val in $types ; do
      if [ "$val" = "htm" ] ; then
          continue
      fi
      echo -n "$val "
  done
  echo "htm"
) > $TEMPTYPES
cat $TEMPTYPES > /usr/local/apache2/conf/mime.types && /bin/rm -f $TEMPTYPES

%pre
# Add the "apache2" user
u=`grep apache2 /etc/passwd`
if [ "$u"x = "x" ]; then
   /usr/sbin/useradd -c "Apache2" \
	-s /bin/false -r -d /usr/local/apache2/htdocs apache2
fi

%preun
if [ $1 = 0 ]; then
   # Stop the service and delete it from the automatic startup.
   /sbin/service httpd2 stop > /dev/null 2>&1
   /sbin/chkconfig --del httpd2
   
   # Delete the apache2 user.
   u=`grep apache2 /etc/passwd`
   if [ "$u"x != "x" ]; then
        /usr/sbin/userdel apache2
   fi
fi
  
%files
%defattr(-,root,root)
%doc ABOUT_APACHE CHANGES INSTALL LICENSE README STATUS
%dir %{apache_dir}/conf
%config %{apache_dir}/conf/httpd.conf
%config %{apache_dir}/conf/magic

%{apache_dir}/conf/mime.types

%{apache_dir}/logs
%{apache_dir}/modules
#%{apache_dir}/etc/httpd/bin
%config /etc/logrotate.d/apache2
%config /etc/rc.d/init.d/httpd2

%dir %{apache_dir}/cgi-bin
%dir %{apache_dir}/htdocs
%config(noreplace) %{apache_dir}/htdocs/index.html
%{apache_dir}/htdocs/apache_pb.gif
%{apache_dir}/icons

%{apache_dir}/man/man1/*
%{apache_dir}/man/man8/ab.8*
#%{apache_dir}/man/man8/httpd.8*
%{apache_dir}/man/man8/logresolve.8*
%{apache_dir}/man/man8/rotatelogs.8*

%{apache_dir}/bin/ab
%{apache_dir}/bin/dbmmanage
%{apache_dir}/bin/htdbm
%{apache_dir}/bin/htdigest
%{apache_dir}/bin/htpasswd
%{apache_dir}/bin/logresolve
%{apache_dir}/bin/rotatelogs
%{apache_dir}/bin/httpd
%attr(4555,root,apache2) %{apache_dir}/bin/httpd2

%{apache_dir}/error

%files manual
%defattr(-,root,root)
%dir %{apache_dir}/manual
%{apache_dir}/manual/*

%files devel
%defattr(-,root,root)
#/etc/httpd/include
%{apache_dir}/include/ap_*
%{apache_dir}/include/[b-z]*
%{apache_dir}/bin/apxs
%{apache_dir}/bin/envvars
%{apache_dir}/man/man8/apxs.8*
%{apache_dir}/build

%files libapr
%defattr(-,root,root)
%{apache_dir}/lib/libapr-0.so*
%{apache_dir}/lib/apr.exp
%{apache_dir}/lib/libaprutil-0.so*
%{apache_dir}/lib/aprutil.exp

%files libapr-devel
%defattr(-,root,root)
%{apache_dir}/bin/apr-config
%{apache_dir}/include/apr*
%{apache_dir}/lib/libapr-0.a
%{apache_dir}/lib/libapr-0.la
%{apache_dir}/bin/apu-config
%{apache_dir}/include/apu*
%{apache_dir}/lib/libaprutil-0.a
%{apache_dir}/lib/libaprutil-0.la
